--*** Flat-shaded cube ***--
--** By Mic, 1999/2000  **--

without warning

include render.e
include stuff.e
include vesa20.e
include graphics.e
include 3dmath.e
include colors.e

sequence points,points2
sequence faces,order,zNormals
sequence pal,shades
sequence v,dv	
integer faceCol
integer XDIM,YDIM,XCENTRE,YCENTRE,SIZE,BPP,key
atom shade
atom vscreen
atom time1,time2,frames
integer wait_retrace

sequence cam,cam2

cam={160,100,-200}
cam2=cam

points2={
 {-1,-1,-1},
 {1,-1,-1},
 {1,1,-1},
 {-1,1,-1},
 {-1,-1,1},
 {1,-1,1},
 {1,1,1},
 {-1,1,1}
}


wait_retrace=1
puts(1,"Flat shaded cube for Euphoria 2.0+\n")
puts(1,"By Mic, 1999/2000\n\n")
puts(1,"Choose a graphics mode:\n")
puts(1," [1] 320*240  (8-bit)\n [2] 640*480  (8-bit)\n [3] 800*600  (8-bit)\n [4] 1024*768 (8-bit)\n")
puts(1," [5] 320*240  (16-bit)\n [6] 640*480  (16-bit)\n [7] 800*600  (16-bit)\n [8] 1024*768 (16-bit)\n")
puts(1," [9] 320*240  (24-bit)\n [a] 640*480  (24-bit)\n [b] 800*600  (24-bit)\n [c] 1024*768 (24-bit)\n [0] Abort mission\n")
puts(1,"Vertical retrace: ON  ([+]=ON [-]=OFF)\n")
puts(1,"\n\nDuring the demonstration:\n")
puts(1," [-] Zoom in\n [+] Zoom out\n [Esc] Exit\n")
key=0
while ((key<'0') or (key>'9')) and ((key<'a') or (key>'c')) do
 key=get_key()
 if key='+' then
  position(18,19)
  puts(1,"ON ")
  wait_retrace=1
 elsif key='-' then
  position(18,19)
  puts(1,"OFF")
  wait_retrace=0
 end if  
end while

if key='0' then
 abort(0)
elsif key='1' then
 XDIM=320
 YDIM=240
 XCENTRE=160
 YCENTRE=120
 SIZE=49
 BPP=8
elsif key='2' then
 XDIM=640
 YDIM=480
 XCENTRE=320
 YCENTRE=240
 SIZE=70
 BPP=8
elsif key='3' then
 XDIM=800
 YDIM=600
 XCENTRE=400
 YCENTRE=300
 SIZE=75
 BPP=8
elsif key='4' then
 XDIM=1024
 YDIM=768
 XCENTRE=512
 YCENTRE=384
 SIZE=75
 BPP=8
elsif key='5' then
 XDIM=320
 YDIM=240
 XCENTRE=160
 YCENTRE=120
 SIZE=49
 BPP=16
elsif key='6' then
 XDIM=640
 YDIM=480
 XCENTRE=320
 YCENTRE=240
 SIZE=70
 BPP=16
elsif key='7' then
 XDIM=800
 YDIM=600
 XCENTRE=400
 YCENTRE=300
 SIZE=75
 BPP=16
elsif key='8' then
 XDIM=1024
 YDIM=768
 XCENTRE=512
 YCENTRE=384
 SIZE=75
 BPP=16
elsif key='9' then
 XDIM=320
 YDIM=240
 XCENTRE=160
 YCENTRE=120
 SIZE=49
 BPP=24
elsif key='a' then
 XDIM=640
 YDIM=480
 XCENTRE=320
 YCENTRE=240
 SIZE=70
 BPP=24
elsif key='b' then
 XDIM=800
 YDIM=600
 XCENTRE=400
 YCENTRE=300
 SIZE=75
 BPP=24
elsif key='c' then
 XDIM=1024
 YDIM=768
 XCENTRE=512
 YCENTRE=384
 SIZE=75
 BPP=24
end if

camX=XCENTRE
camY=YCENTRE

points2=points2*(SIZE-9)
SIZE=SIZE*2

pal=repeat({0,0,0},256)
for i=1 to 63 do
 pal[i]={floor(i/6),floor(i/6),i}
end for
if BPP=16 then
 --** colors of each face (kinda) **--
 shades={
  {1,0.5,0},{0.3,0.7,0.1},{0.2,1,0.8},{0.1,0.4,1},{0,1,0.7},{0.6,0.2,1}
 }
elsif BPP=24 then
 shades={
  {1,0.3,0.3},{1,0.3,0.3},{0.3,1,0.3},{0.3,0.3,1},{0.3,1,0.3},{0.3,0.3,1}
 }
end if

if vesa_mode(XDIM,YDIM,BPP) then
 puts(2,"Doh! Unable to set graphics mode!\n")
 puts(2,"Possible reasons:\n * No VESA driver installed.\n * Your videocard sucks..\n")
 abort(1)
end if
if mode_type=BANKED then
 puts(2,"Doh! Unable to get a linear framebuffer!\n")
 abort(1) 
end if

 
if render_mode(XDIM,YDIM,BPP) then end if
vscreen=allocate(XDIM*YDIM*(BPP/8))		--allocate a virtual screen
if vscreen=0 then
 puts(2,"Doh! Unable to allocate memory for virtual screen!\n")
 abort(1)
end if
cls(vscreen,0)
if BPP=8 then set_pal(pal) end if 


v={30,30,30}
dv={1,1,1}
frames=0
time1=time()
key=0
while key!=27 do 
 key=get_key()
 clear_area(vscreen,0,{{XCENTRE-SIZE,YCENTRE-SIZE},{XCENTRE+SIZE,YCENTRE+SIZE}})
 --*** Rotate the points ***--
 points=rotate(points2,{1,1,1},v)
 faces={
  points[1..4],
  points[5..8],
  {points[1],points[2],points[6],points[5]},
  {points[6],points[2],points[3],points[7]},
  {points[4],points[3],points[7],points[8]},
  {points[1],points[5],points[8],points[4]}  
 }
 --*** Get the z-normals of the faces ***--
 zNormals=get_quad_zNormal(faces) 
 order=sort_faces(faces)
 --faces=get_screen_xy({XCENTRE,YCENTRE},faces)
 faces=GetScreenXY(faces)
 for i=1 to 6 do
  --*** Is the face visible ? ***--
  if zNormals[order[i]]>=0 then
   --*** This is where the shading is done                                   ***--
   --*** The formula is:                                                     ***--
   --*** span=abs(minZ-maxZ)           ***--
   --*** shade=((center/4)+abs(minZ))/span                                   ***--
   --*** color=(number_of_shades-floor(number_of_shades*shade))+first_color  ***--             
   shade=((m19_centers[i]/4)+(SIZE/2))/(SIZE-15)
   if BPP=8 then
    faceCol=(60-floor(60*shade))   
    asm_quad_ex(faces[order[i]],faceCol,vscreen)
   elsif BPP=24 then
    faceCol=(170-floor(250*shade))   
    asm_quad_ex(faces[order[i]],makecol24(floor(shades[order[i]]*faceCol)),vscreen)
   else
    faceCol=(170-floor(250*shade))   
    asm_quad_ex(faces[order[i]],makecol16(floor(shades[order[i]]*faceCol)),vscreen)
   end if   
  end if
 end for
 if wait_retrace then wait_vrt() end if
 single_copy(screen_copy, {vscreen, video_mem, XDIM*(BPP/8),YDIM, XDIM*(BPP/8), bytes_per_line})
 --fcopy_screen(video_mem,vscreen)
 frames=frames+1
 v=v+dv
 for i=1 to 3 do
  if v[i]>=361 then
   v[i]=1
  end if
  if v[i]<1 then
   v[i]=360
  end if
 end for
 --*** Randomize the rotating ***--
 if rand(150)=1 then
  dv=rand({6,6,6})-3
 end if
 if key='+' then
  camZ=camZ-10
 elsif key='-' then
  camZ=camZ+10
 end if
end while
time2=time()

if graphics_mode(-1) then end if
free(vscreen)

printf(1,"%d frames per second.\n",floor(frames/(time2-time1)))

