without warning

include vesa20.e
include graphics.e
include render.e
include colors.e
include stuff.e

integer XDIM,YDIM,BPP,key
sequence pal
atom SIZE


puts(1,"Choose a graphics mode:\n")
puts(1," [1] 320*240  (8-bit)\n [2] 640*480  (8-bit)\n [3] 800*600  (8-bit)\n [4] 1024*768 (8-bit)\n")
puts(1," [5] 320*240  (15-bit)\n [6] 640*480  (15-bit)\n [7] 800*600  (15-bit)\n [8] 1024*768 (15-bit)\n")
puts(1," [9] 320*240  (16-bit)\n [a] 640*480  (16-bit)\n [b] 800*600  (16-bit)\n [c] 1024*768 (16-bit)\n")
puts(1," [d] 320*240  (24-bit)\n [e] 640*480  (24-bit)\n [f] 800*600  (24-bit)\n [g] 1024*768 (24-bit)\n [0] Abort mission\n")
key=0
while ((key<'0') or (key>'9')) and ((key<'a') or (key>'g')) do
 key=get_key()
end while
if key='0' then
 abort(0)
elsif key='1' then
 XDIM=320
 YDIM=240
 SIZE=1
 BPP=8
elsif key='2' then
 XDIM=640
 YDIM=480
 SIZE=2
 BPP=8
elsif key='3' then
 XDIM=800
 YDIM=600
 SIZE=2.5
 BPP=8
elsif key='4' then
 XDIM=1024
 YDIM=768
 SIZE=3.2
 BPP=8
elsif key='5' then
 XDIM=320
 YDIM=240
 SIZE=1
 BPP=15
elsif key='6' then
 XDIM=640
 YDIM=480
 SIZE=2
 BPP=15
elsif key='7' then
 XDIM=800
 YDIM=600
 SIZE=2.5
 BPP=15
elsif key='8' then
 XDIM=1024
 YDIM=768
 SIZE=3.2
 BPP=15
elsif key='9' then
 XDIM=320
 YDIM=240
 SIZE=1
 BPP=16
elsif key='a' then
 XDIM=640
 YDIM=480
 SIZE=2
 BPP=16
elsif key='b' then
 XDIM=800
 YDIM=600
 SIZE=2.5
 BPP=16
elsif key='c' then
 XDIM=1024
 YDIM=768
 SIZE=3.2
 BPP=16
elsif key='d' then
 XDIM=320
 YDIM=240
 SIZE=1
 BPP=24
elsif key='e' then
 XDIM=640
 YDIM=480
 SIZE=2
 BPP=24
elsif key='f' then
 XDIM=800
 YDIM=600
 SIZE=2.5
 BPP=24
elsif key='g' then
 XDIM=1024
 YDIM=768
 SIZE=3.2
 BPP=24
end if

if vesa_mode(XDIM,YDIM,BPP) then
 puts(2,"Doh! Unable to set graphics mode!\n")
 puts(2,"Possible reasons:\n * No VESA driver installed.\n * Your videocard sucks..\n")
 abort(1)
end if
if mode_type=BANKED then
 puts(2,"Doh! Unable to get a linear framebuffer!\n")
 abort(1) 
end if
if render_mode(XDIM,YDIM,BPP) then end if

--** define the palette used by makecol8() **--
if BPP=8 then
 pal=repeat({0,0,0},256)
 for i=0 to 63 do
  pal[i+1]={0,i,0}
  pal[i+64]={i,63,i}
 end for
 pal[128]={18,18,60}
 pal[129]={60,18,60}
 pal[130]={29,48,17}
 makecol_palette(pal)
 set_pal(pal)
end if

--** video_mem is a variable in Vesa20.e **--

asm_tri_ex(floor({{70,10},{100,70},{20,50}}*SIZE),makecol(BPP,{63,94,210}),video_mem)

asm_gouraudtri_ex(floor({{140,10},{200,80},{130,90}}*SIZE),{makecol(BPP,{220,33,33}),makecol(BPP,{33,250,33}),makecol(BPP,{170,170,170})},video_mem)

asm_quad_ex(floor({{40,110},{80,118},{78,169},{43,156}}*SIZE),makecol(BPP,{225,53,221}),video_mem)

asm_gouraudquad_ex(floor({{110,110},{170,140},{178,190},{119,170}}*SIZE),
                   {makecol(BPP,{200,75,75}),makecol(BPP,{20,90,20}),makecol(BPP,{8,184,184}),makecol(BPP,{67,4,70})},video_mem)

asm_polygon_ex(floor({{270,130},{310,130},{330,150},{330,190},{310,210},{270,210},{250,190},{250,150}}*SIZE),makecol(BPP,{110,140,65}),video_mem)


while get_key()=-1 do
end while

if graphics_mode(-1) then end if
 